SystemOrganization addCategory: #'GMF-Window'!

Morph subclass: #GMFViewMorph
	instanceVariableNames: 'surface session derivation class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!GMFViewMorph methodsFor: 'session' stamp: 'volosmat 11/7/2013 22:41'!
checkSession
	session == Smalltalk session ifFalse: [ 
		"just reset the surface"
		surface := nil.
		session := Smalltalk session.
	]! !

!GMFViewMorph methodsFor: 'drawing' stamp: 'RostislavNovak 12/19/2013 00:42'!
drawOn: aCanvas
	self checkSession.
	surface
		ifNil: [ 
			surface := AthensCairoSurface extent: self extent asIntegerPoint. ].
	Facade getDiagram notNil
		ifTrue: [ 
			Facade getDiagram drawOnSurface: surface ].
	aCanvas drawImage: surface asForm at: bounds origin! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:30'!
handlesMouseDown: anEvent 
    ^true! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:26'!
handlesMouseOver: anEvent 
    ^true! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:45'!
handlesMouseWheel: anEvent 
    ^true! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'volosmat 11/7/2013 22:41'!
initialize
	super initialize.
	session := Smalltalk session.
	
	self hResizing: #spaceFill;
		 vResizing: #spaceFill! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'volosmat 12/19/2013 21:59'!
mouseDown: anEvent
	anEvent redButtonPressed
		ifTrue: [ derivation := anEvent cursorPoint ].	"click"
	anEvent yellowButtonPressed
		ifTrue: [ 
			derivation := anEvent cursorPoint.
			class := [ Facade getClasses detect: [ :e | e isIn: ((anEvent cursorPoint - anEvent targetPoint) - (GMFGADrawableObject shift)/GMFGADrawableObject scale) ] ]
				on: Error
				do: [ class := nil ].
			Transcript show: class name ].
	self changed! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:26'!
mouseEnter: anEvent 
    anEvent hand newKeyboardFocus: self! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:35'!
mouseLeave: anEvent
    anEvent hand newKeyboardFocus: nil! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/19/2013 00:23'!
mouseUp: anEvent
	anEvent redButtonChanged
		ifTrue: [ 
			derivation := anEvent cursorPoint - derivation.
			GMFGADrawableObject transformationX: derivation x Y: derivation y. ].	
	anEvent yellowButtonChanged
		ifTrue: [ 
			derivation := anEvent cursorPoint - derivation.
			class ifNotNil: [ class move: derivation ] ].
	self changed! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/19/2013 00:14'!
mouseWheel: anEvent
	anEvent direction = 'up'
		ifTrue: [ GMFGADrawableObject scale: (GMFGADrawableObject scale * 1.1) ]
		ifFalse: [ GMFGADrawableObject scale: (GMFGADrawableObject scale * 0.9) ].
	self changed! !

Object subclass: #GMFDialogWindow
	instanceVariableNames: 'name classList delete'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

GMFDialogWindow subclass: #AssociationWindow
	instanceVariableNames: 'startList associationList endList typeList startQuantity endQuantity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/12/2013 00:01'!
associationList
	^ associationList! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/12/2013 00:01'!
associationList: anObject
	associationList := anObject! !

!AssociationWindow methodsFor: 'check' stamp: 'volosmat 12/19/2013 22:17'!
checkEnteredData
	super checkEnteredData 
		ifFalse: [^ false].
	startQuantity = '' | startQuantity isNil | endQuantity = '' | endQuantity isNil | classList hasSelected not | ( startList selectionIndex <= 1) | ( endList selectionIndex <= 1 )
		ifTrue: [GMF alertDialog: 'Error, to creating attribute. Required fields are name, start/end quantity , select start/end class and select class for association.'.
			^ false].
	^ true! !

!AssociationWindow methodsFor: 'check' stamp: 'volosmat 12/21/2013 09:54'!
checkUniqueName
	((Facade getClass: startList selectedItem) metaModelClass associations
			allSatisfy: [:each | (each name ~= name) | ( associationList selectedItem = name )])
		ifFalse: [GMF alertDialog: 'Error to creating/editing start association class. Association ', name ,' is not unique in class ', startList selectedItem.
			^ false].
	((Facade getClass: endList selectedItem) metaModelClass associations
			allSatisfy: [:each | ( each name ~= name ) | ( associationList selectedItem = name )]) 
		ifFalse: [GMF alertDialog: 'Error to creating/editing end association class. Association ', name ,' is not unique in class ', endList selectedItem.
			^ false].
	^ true! !

!AssociationWindow methodsFor: 'ok actions' stamp: 'volosmat 12/21/2013 09:47'!
doOnOK
	| association startClass endClass drawAssociation |
	associationList hasSelected not
		ifTrue: [association := Compiler evaluate: typeList selectedItem , ' new'.
			startClass := Facade getClass: startList selectedItem. 
			endClass := Facade getClass: endList selectedItem.
			association start: startClass metaModelClass.
			association end: endClass metaModelClass.
			association start associations add: association.
			association end associations add: association.
			drawAssociation := Compiler evaluate: 'GMFGA' , typeList selectedItem , ' new'.
			drawAssociation leftGAElement: startClass;
				 rightGAElement: endClass;
				 metaModelClass: association.
			Facade addAssociation: drawAssociation];
		
		ifFalse: [association := (Facade getClass: classList selectedItem) metaModelClass searchAssociation: associationList selectedItem.
			drawAssociation := Facade getAssociation: association name start: association start name end: association end name.
			association start name ~= startList selectedItem
				ifTrue: [association start removeAssociation: name.
					association start: (Facade getClass: startList selectedItem) metaModelClass.
					association start associations add: association].
			association end name ~= endList selectedItem
				ifTrue: [association end removeAssociation: name.
					association end: (Facade getClass: endList selectedItem) metaModelClass.
					association end associations add: association].
			delete
				ifTrue: [Facade
						removeAssociation: (Facade
								getAssociation: associationList selectedItem
								start: association start name
								end: association end name)]].
	association name: name.
	association startQuantity: startQuantity.
	association endQuantity: endQuantity! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/17/2013 00:05'!
endList
	^ endList! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/17/2013 00:05'!
endList: anObject
	endList := anObject! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/17/2013 20:39'!
endQuantity
	^ endQuantity  ifNil: [  endQuantity := '0' ]! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:47'!
endQuantity: anObject
	endQuantity := anObject! !

!AssociationWindow methodsFor: 'initialize-release' stamp: 'volosmat 12/18/2013 00:24'!
initialize
	delete := false.
	classList := AssociationClassList new dialogWindow: self.
	associationList := AssociationList new dialogWindow: self; firstItem: 'New association'.
	typeList := ListModel new list: #('Characterization' 'Derivation' 'Mediation' 'ComponentOf' 'MemberOf' 'SubCollectionOf'  'SubQuantityOf' 'FormalAssociation' 'MaterialAssociation'); selectionIndex: 1.
	startList := ListModel new list: ( classList list ); selectionIndex: 1.
	endList := ListModel new list: ( classList list ); selectionIndex: 1.! !

!AssociationWindow methodsFor: 'open' stamp: 'volosmat 12/21/2013 09:12'!
openModal
	| builder dialog content |
 
	builder := UITheme builder.

 	content := (builder newLabelGroup: {
			'Class:' -> (builder
						newDropListFor: classList
						list: #list
						getSelected: #selectionIndex
						setSelected: #selectionIndex:
						help: 'Association class'). 
			'Associations:' -> (builder
						newDropListFor: associationList
						list: #list
						getSelected: #selectionIndex
						setSelected: #selectionIndex:
						help: 'Association'). 
			'Type:'->(  builder 
						newDropListFor: typeList
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Start class').
			'Start class:'->(  builder 
						newDropListFor: startList
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Start class').
  			
  			'Start quantity:' ->(( builder
   						newTextEntryFor: self
						getText: #startQuantity  
						setText: #startQuantity: 
						help: 'Enter start quantity')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'End class:'->(  builder 
						newDropListFor: endList
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Start class').
			'End quanitity:' ->(( builder
   						newTextEntryFor: self
						getText: #endQuantity  
						setText: #endQuantity: 
						help: 'Enter end quantity')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Name:' ->(( builder
   						newTextEntryFor: self
						getText: #name  
						setText: #name: 
						help: 'Enter name of association')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Delete:'->(builder 
					newCheckboxFor: self
					getSelected: #delete 
					setSelected: #delete: 
					label: '' 
					help: 'Delete association').
	}).
	dialog := builder newPluggableDialogWindow:'Create association' for: content.
	builder openModal: dialog.
	
	dialog cancelled not  
		ifTrue: [ self checkEnteredData 
			ifTrue: [ self checkUniqueName ifTrue: [ self doOnOK] ] ]! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/12/2013 00:01'!
startList
	^ startList! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/12/2013 00:01'!
startList: anObject
	startList := anObject! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/12/2013 00:31'!
startQuantity
	^ startQuantity ifNil: [ startQuantity := '0' ]! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:48'!
startQuantity: anObject
	startQuantity := anObject! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/12/2013 00:02'!
typeList
	^ typeList! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 12/12/2013 00:02'!
typeList: anObject
	typeList := anObject! !

GMFDialogWindow subclass: #AttributeWindow
	instanceVariableNames: 'dataType instance quantity attributeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AttributeWindow methodsFor: 'accessing' stamp: 'volosmat 12/11/2013 22:56'!
attributeList
	^ attributeList! !

!AttributeWindow methodsFor: 'accessing' stamp: 'volosmat 12/11/2013 22:56'!
attributeList: anObject
	attributeList := anObject! !

!AttributeWindow methodsFor: 'check' stamp: 'volosmat 12/19/2013 22:07'!
checkEnteredData
	super checkEnteredData 
		ifFalse: [^ false].
	quantity = '' | quantity isNil | dataType = '' | dataType isNil | classList hasSelected not
		ifTrue: [GMF alertDialog: 'Error, to creating attribute. Required fields are name, data type, quantity and select class for attribute.'.
			^ false].
	^ true! !

!AttributeWindow methodsFor: 'check' stamp: 'volosmat 12/21/2013 09:51'!
checkUniqueName
	((Facade getClass: classList selectedItem) metaModelClass attributes
		allSatisfy: [:each | ( each name ~= name) | ( name = attributeList selectedItem )]) 
			ifTrue: [ ^ true ].
	GMF alertDialog: 'Error to creating/editing attribute name. Attribute ', name, ' is not unique in class ', classList selectedItem.	
	^ false! !

!AttributeWindow methodsFor: 'accessing' stamp: 'volosmat 11/25/2013 23:46'!
dataType
	^ dataType! !

!AttributeWindow methodsFor: 'accessing' stamp: 'volosmat 11/25/2013 23:46'!
dataType: anObject
	dataType := anObject! !

!AttributeWindow methodsFor: 'ok actions' stamp: 'volosmat 12/19/2013 21:49'!
doOnOK
	| class |
	class := (Facade getClass: classList selectedItem) metaModelClass.
	attributeList hasSelected not
		ifTrue: [class attributes
				add: (Attribute
						name: name
						dataType: dataType
						quantity: quantity
						instance: instance)];
		
		ifFalse: [(class searchAttribute: attributeList selectedItem) name: name;
				 dataType: dataType;
				 quantity: quantity;
				 instance: instance.
			delete
				ifTrue: [class removeAttribute: name]].
! !

!AttributeWindow methodsFor: 'initialize-release' stamp: 'volosmat 12/18/2013 00:22'!
initialize 
	instance := true.
	delete := false.
	classList := AttributeClassList new dialogWindow: self.
	attributeList := AttributeList new dialogWindow: self; firstItem: 'New attribute'! !

!AttributeWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 13:30'!
instance
	^ instance! !

!AttributeWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 11:50'!
instance: anObject
	instance := anObject! !

!AttributeWindow methodsFor: 'open' stamp: 'volosmat 12/21/2013 09:12'!
openModal
	| builder dialog content |
	builder := UITheme builder.
	
	content := builder newLabelGroup: {
			'Class:' -> (builder
							newDropListFor: classList
							list: #list
							getSelected: #selectionIndex
							setSelected: #selectionIndex:
							help: 'Attribut class'). 
			'Attribut:' -> (builder
							newDropListFor: attributeList
							list: #list
							getSelected: #selectionIndex
							setSelected: #selectionIndex:
							help: 'Attribut'). 
			'Name:' -> ((builder
							newTextEntryFor: self
							getText: #name
							setText: #name:
							help: 'Enter attribut name') 
						acceptOnCR: false;
						minWidth: 200). 
			'Data type:' -> ((builder
							newTextEntryFor: self
							getText: #dataType
							setText: #dataType:
							help: 'Enter attribut data type') 
						acceptOnCR: false;
						minWidth: 200). 
			'Quantity:' -> ((builder
							newTextEntryFor: self
							getText: #quantity
							setText: #quantity:
							help: 'Enter attribut quantity') 
						acceptOnCR: false;
						minWidth: 200). 
			'Instance:' -> (builder
							newCheckboxFor: self
							getSelected: #instance
							setSelected: #instance:
							label: ''
							help: 'Instance attribut').
							
			'Delete:'->(builder 
						newCheckboxFor: self
						getSelected: #delete 
						setSelected: #delete: 
						label: '' 
						help: 'Delete attribut').
							}.
	dialog := builder newPluggableDialogWindow: 'Create attribute' for: content.
	builder openModal: dialog.
	dialog cancelled not  
		ifTrue: [ self checkEnteredData 
			ifTrue: [ self checkUniqueName ifTrue: [ self doOnOK] ] ]! !

!AttributeWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 18:00'!
quantity
	^ quantity ifNil: [ quantity:= 1 ]! !

!AttributeWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 11:51'!
quantity: anObject
	quantity := anObject! !

GMFDialogWindow subclass: #ElementWindow
	instanceVariableNames: 'parent parentList typeList parentListChoice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!ElementWindow methodsFor: 'private' stamp: 'volosmat 12/21/2013 08:24'!
addParentsToClass: xClass 
	| start |
	parent
		do: [:each | 
			start := Facade getClass: each.
			xClass metaModelClass parent: start metaModelClass. 
			Facade
				addAssociation: (GMFGAInheritance
						metaModelClass: (FormalAssociation
								name: ''
								start: start metaModelClass
								end: xClass metaModelClass)
						leftClass: xClass
						rightClass: start)]! !

!ElementWindow methodsFor: 'check' stamp: 'volosmat 12/21/2013 09:50'!
checkUniqueName
	(Facade getClasses 
		allSatisfy: [:each | (each metaModelClass name ~= name) | (name = classList selectedItem)]) 
			ifTrue: [ ^ true ].
	GMF alertDialog: 'Error to creating/editing element name. Element ', name, ' is not unique'.	
	^ false! !

!ElementWindow methodsFor: 'private' stamp: 'volosmat 11/28/2013 19:02'!
deleteParentFromList
	parentList selectionIndex > 0
		ifTrue: [parent removeAt: parentList selectionIndex.
			parentList selectionIndex: 0.
			parentList list: parent.
			parentList changed: #list]! !

!ElementWindow methodsFor: 'ok actions' stamp: 'volosmat 12/21/2013 08:35'!
doOnOK
	| element class |
	classList hasSelected not
		ifTrue: [element := Compiler evaluate: typeList selectedItem , ' new'.
			element name: name.
			class := GMFGAClass metaModelClass: element.
			Facade addClass: class. 
			self addParentsToClass: class];
		
		ifFalse: [class := Facade getClass: classList selectedItem.
			class metaModelClass name: name.
			class metaModelClass parent removeAll.
			class metaModelClass disjoint removeAll.
			Facade removeClassInheritance: class.
			self addParentsToClass: class.
			delete
				ifTrue: [Facade removeClass: class] ]! !

!ElementWindow methodsFor: 'initialize-release' stamp: 'volosmat 12/20/2013 00:51'!
initialize
	delete := false.
	classList := ClassList new dialogWindow: self; firstItem: 'New class'.
	parentListChoice := ParentList new dialogWindow: self; firstItem: 'Select parent ...'.
	parent := OrderedCollection new.
	parentList := ListModel new list: parent.
	typeList := ListModel new list: #('Kind' 'SubKind' 'Phase' 'Role' 'Mode' 'Role' 'Relator' 'RoleMixin' 'Mixin' 'Category' 'Collective' 'Quantity' 'Quality');
				selectionIndex: 1! !

!ElementWindow methodsFor: 'open' stamp: 'volosmat 12/21/2013 09:05'!
openModal
	| builder dialog content |
 
	builder := UITheme builder.
	
	content := (builder newLabelGroup: {
			'Action:'->(  builder 
						newDropListFor: classList
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Element type').
			'Type:'->(  builder 
						newDropListFor: typeList
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Element type').
			'Select parent:'->(  builder 
						newDropListFor: parentListChoice
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Element parent').
			'Parent List'->((builder newListFor: parentList
						list: #list 
						selected: #selectionIndex 
						changeSelected: #selectionIndex:
						help: 'Selected parents') 
					minWidth: 120).
			''->(builder newButtonFor: self 
						action: #deleteParentFromList 
						label: 'Delete parent' 
						help: 'Delete parent').
  			'Name:' ->(( builder
   						newTextEntryFor: self
						getText: #name 
						setText: #name: 
						help: 'Enter element name')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Delete:'->(builder 
						newCheckboxFor: self
						getSelected: #delete 
						setSelected: #delete: 
						label: '' 
						help: 'Instance attribut').
	}).
	dialog := builder newPluggableDialogWindow:'Create element' for: content.
	builder openModal: dialog.

	dialog cancelled not  
		ifTrue: [ self checkEnteredData & self checkUniqueName ifTrue: [ self doOnOK] ] ! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 15:24'!
parent
	^ parent ifNil: [ parent := OrderedCollection new ]! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 15:20'!
parent: anObject
	parent := anObject! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 21:24'!
parentAdd: xParent
	xParent = name 
		ifTrue: [ ^ GMF alertDialog: 'Error, element ', name,' can not inherits from itself.' ].
		
	[ parent detect: [ :each | each == xParent ] ]
		on: Error 
		do: [ ^parent add: xParent ].
		
	^ GMF alertDialog: 'Error, element ', xParent,' is already in collection element parents.'! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 14:45'!
parentList
	^ parentList! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 14:45'!
parentList: anObject
	parentList := anObject! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 21:23'!
parentListChoice
	^ parentListChoice! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 21:23'!
parentListChoice: anObject
	parentListChoice := anObject! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 12/11/2013 21:03'!
typeList
	^typeList! !

!GMFDialogWindow methodsFor: 'check' stamp: 'volosmat 12/19/2013 21:46'!
checkEnteredData
	 name = '' | name isNil
		ifTrue: [GMF alertDialog: 'Error, you must enter name first.'.
			^ false]. 
	^ true! !

!GMFDialogWindow methodsFor: 'check' stamp: 'volosmat 12/21/2013 08:57'!
checkUniqueName
	^ self subclassResponsibility ! !

!GMFDialogWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 19:49'!
classList
	^ classList! !

!GMFDialogWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 19:49'!
classList: anObject
	classList := anObject! !

!GMFDialogWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 19:49'!
delete
	^ delete! !

!GMFDialogWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 19:49'!
delete: anObject
	delete := anObject! !

!GMFDialogWindow methodsFor: 'ok actions' stamp: 'volosmat 12/19/2013 19:44'!
doOnOK
	^ self subclassResponsibility! !

!GMFDialogWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 19:49'!
name
	^ name! !

!GMFDialogWindow methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 19:49'!
name: anObject
	name := anObject! !

!GMFDialogWindow methodsFor: 'open' stamp: 'volosmat 12/19/2013 19:45'!
openModal
	^ self subclassResponsibility ! !

GMFDialogWindow subclass: #MethodWindow
	instanceVariableNames: 'returnDataType parameters instance abstract methodList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:44'!
abstract
	^ abstract! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:44'!
abstract: anObject
	abstract := anObject! !

!MethodWindow methodsFor: 'check' stamp: 'volosmat 12/19/2013 22:07'!
checkEnteredData
	super checkEnteredData 
		ifFalse: [^ false].
	classList hasSelected not
		ifTrue: [GMF alertDialog: 'Error, to creating method. You must select class for method.'.
			^ false].
	^ true! !

!MethodWindow methodsFor: 'check' stamp: 'volosmat 12/21/2013 09:52'!
checkUniqueName
	((Facade getClass: classList selectedItem) metaModelClass methods
		allSatisfy: [:each | (each name ~= name) | (name = methodList selectedItem)]) 
			ifTrue: [ ^ true ].
	GMF alertDialog: 'Error to creating/editing method name. Method ', name, ' is not unique in class ', classList selectedItem.	
	^ false! !

!MethodWindow methodsFor: 'ok actions' stamp: 'volosmat 12/19/2013 14:45'!
doOnOK
	| class paramCol |
	name isNil | returnDataType isNil | classList hasSelected not
		ifTrue: [^ GMF alertDialog: 'Error. Required fields are name, class, return data type.'].
	class := (Facade getClass: classList selectedItem) metaModelClass.
	parameters notNil & parameters ~= ''
		ifTrue: [paramCol := ' ' split: parameters. 
			[(paramCol at: paramCol size) = '']
				whileTrue: [paramCol removeLast]]; 
		
		ifFalse: [paramCol := OrderedCollection new].
	methodList hasSelected not
		ifTrue: [class methods
				add: (Method
						name: name
						returnDataType: returnDataType
						abstract: abstract
						instance: instance
						parameters: paramCol)];
		
		ifFalse: [(class searchMethod: methodList selectedItem) name: name;
				 returnDataType: returnDataType;
				 abstract: abstract;
				 instance: instance;
				 parameters: paramCol.
			delete
				ifTrue: [class removeMethod: name]].! !

!MethodWindow methodsFor: 'initialize-release' stamp: 'volosmat 12/18/2013 00:23'!
initialize 
	delete := false.
	instance := true.
	abstract := false.
	classList := MethodClassList new dialogWindow: self.
	methodList := MethodList new dialogWindow: self; firstItem: 'New method'.! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:44'!
instance
	^ instance! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:44'!
instance: anObject
	instance := anObject! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:24'!
methodList
	^ methodList! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:24'!
methodList: anObject
	methodList := anObject! !

!MethodWindow methodsFor: 'open' stamp: 'volosmat 12/21/2013 09:04'!
openModal
	| builder dialog content |
 
	builder := UITheme builder.

 	content := (builder newLabelGroup: {
			'Class:'->(  builder 
						newDropListFor: classList
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Method class').
			'Method:'->(  builder 
						newDropListFor: methodList
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Method').
  			'Name:' ->(( builder
   						newTextEntryFor: self
						getText: #name 
						setText: #name: 
						help: 'Enter attribut name')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Parameters:' ->(( builder
   						newTextEntryFor: self
						getText: #parameters 
						setText: #parameters: 
						help: 'Enter method parameters')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Return data type' ->(( builder
   						newTextEntryFor: self
						getText: #returnDataType  
						setText: #returnDataType: 
						help: 'Enter return data type')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Instance:'->(builder 
						newCheckboxFor: self
						getSelected: #instance 
						setSelected: #instance: 
						label: '' 
						help: 'Instance method').
			'Abstract:'->(builder 
						newCheckboxFor: self
						getSelected: #abstract 
						setSelected: #abstract: 
						label: '' 
						help: 'Abstract method').
			'Delete:'->(builder 
						newCheckboxFor: self
						getSelected: #delete 
						setSelected: #delete: 
						label: '' 
						help: 'Delete method').
	}).
	dialog := builder newPluggableDialogWindow:'Create method' for: content.
	builder openModal: dialog.
 
	dialog cancelled not  
		ifTrue: [ self checkEnteredData & self checkUniqueName ifTrue: [ self doOnOK] ] ! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:59'!
parameters
	^ parameters ifNil: [ ^'param1 param2 param3' ]! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:45'!
parameters: anObject
	parameters := anObject! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 22:22'!
returnDataType
	^ returnDataType ifNil: [ returnDataType := 'void' ]! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:45'!
returnDataType: anObject
	returnDataType := anObject! !

Object subclass: #GMFList
	instanceVariableNames: 'selectedIndex dialogWindow firstItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

GMFList subclass: #AssociationList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AssociationList methodsFor: 'list' stamp: 'volosmat 12/18/2013 00:20'!
list
	| associationsList |
	associationsList := OrderedCollection new.
	associationsList add: firstItem.
	dialogWindow classList hasSelected
		ifTrue: [(Facade getClass: dialogWindow classList selectedItem) metaModelClass associations 
				do: [:each | associationsList add: each name]].
	^ associationsList! !

!AssociationList methodsFor: 'list' stamp: 'volosmat 12/17/2013 20:42'!
selectionIndex: xIndex 
	| association |
	selectedIndex := xIndex.
	self hasSelected
		ifTrue: [association := (Facade getClass: dialogWindow classList selectedItem) metaModelClass searchAssociation: self selectedItem.
			dialogWindow name: association name.
			dialogWindow startQuantity: association startQuantity.
			dialogWindow endQuantity: association endQuantity.
			self selectItemInList: dialogWindow startList item: association start name.
			self selectItemInList: dialogWindow endList item: association end name.
			self selectItemInList: dialogWindow typeList item: association class asString];
		
		ifFalse: [dialogWindow name: nil. 
			dialogWindow startQuantity: '0'.
			dialogWindow endQuantity: '0'.
			dialogWindow startList selectionIndex: 1.
			dialogWindow endList selectionIndex: 1.
			dialogWindow typeList selectionIndex: 1].
	self changed: #selectionIndex;
		 changed: #hasSelected.
	dialogWindow changed: #name;
		 changed: #startQuantity;
		 changed: #endQuantity.
	dialogWindow startList changed: #selectionIndex.
	dialogWindow endList changed: #selectionIndex.
	dialogWindow typeList changed: #selectionIndex! !

GMFList subclass: #AttributeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AttributeList methodsFor: 'list' stamp: 'volosmat 12/18/2013 00:20'!
list
	| attributsList |
	attributsList := OrderedCollection new.
	attributsList add: firstItem.
	dialogWindow classList hasSelected
		ifTrue: [(Facade getClass: dialogWindow classList selectedItem) metaModelClass attributes 
				do: [:each | attributsList add: each name]].
	^ attributsList! !

!AttributeList methodsFor: 'list' stamp: 'volosmat 12/17/2013 17:52'!
selectionIndex: xIndex 
	| attribut |
	selectedIndex := xIndex.
	self hasSelected
		ifTrue: [attribut := (Facade getClass: dialogWindow classList selectedItem) metaModelClass searchAttribute: self selectedItem.
			dialogWindow name: attribut name.
			dialogWindow quantity: attribut quantity.
			dialogWindow dataType: attribut dataType.
			dialogWindow instance: attribut instance];
		
		ifFalse: [dialogWindow name: nil.
			dialogWindow quantity: 1.
			dialogWindow dataType: nil.
			dialogWindow instance: true].
	self changed: #selectionIndex;
		 changed: #hasSelected.
	dialogWindow changed: #name; 
		 changed: #quantity;
		 changed: #dataType;
		 changed: #instance! !

GMFList subclass: #ClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

ClassList subclass: #AssociationClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AssociationClassList methodsFor: 'list' stamp: 'volosmat 12/17/2013 21:11'!
selectionIndex: xIndex
	selectedIndex := xIndex.
	dialogWindow associationList selectionIndex: 1.
	dialogWindow associationList changed: #list.
	dialogWindow associationList changed: #selectionIndex.
	
	self selectItemInList: dialogWindow startList item: self selectedItem. 
	dialogWindow startList changed: #selectionIndex.

	self changed: #selectionIndex;
		 changed: #hasSelected. 
! !

ClassList subclass: #AttributeClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AttributeClassList methodsFor: 'list' stamp: 'volosmat 12/17/2013 21:12'!
selectionIndex: xIndex
	selectedIndex := xIndex.
	dialogWindow attributeList selectionIndex: 1. 
	dialogWindow name: nil.
	dialogWindow dataType: nil.
	dialogWindow quantity: 1.
	dialogWindow instance: true.
	self changed: #selectionIndex;
		 changed: #hasSelected.
	dialogWindow attributeList changed: #list.
	dialogWindow changed: #name;
		 changed: #quantity;
		 changed: #dataType;
		 changed: #instance! !

!ClassList methodsFor: 'list' stamp: 'volosmat 12/18/2013 00:19'!
list
	| classList |
	classList := OrderedCollection new.
	classList add: firstItem.
	Facade getClasses
		do: [:each | classList add: each metaModelClass name].
	^ classList ! !

!ClassList methodsFor: 'list' stamp: 'volosmat 12/19/2013 21:23'!
selectionIndex: xIndex 
	| class |
	selectedIndex := xIndex.
	dialogWindow parent: OrderedCollection new.
	self hasSelected
		ifTrue: [class := (Facade getClass: self selectedItem) metaModelClass.
			dialogWindow name: class name.
			self selectItemInList: dialogWindow typeList item: class class asString.
			dialogWindow parent: OrderedCollection new.
			class parent
				do: [:each | dialogWindow parentAdd: (Facade getClass: each name) metaModelClass name]];
		
		ifFalse: [dialogWindow name: nil.
			dialogWindow typeList selectionIndex: 1.
			dialogWindow parentListChoice selectionIndex: 1 ].
	self changed: #selectionIndex.
	dialogWindow changed: #name.
	dialogWindow parentList list: dialogWindow parent.
	dialogWindow parentList changed: #list! !

ClassList subclass: #MethodClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!MethodClassList methodsFor: 'list' stamp: 'volosmat 12/17/2013 21:12'!
selectionIndex: xIndex
	selectedIndex := xIndex.
	dialogWindow methodList selectionIndex: 1.
	dialogWindow name: nil. 
	dialogWindow returnDataType: nil.
	dialogWindow parameters: 'param1 param2 param3'.
	dialogWindow instance: true.
	dialogWindow abstract: false.
	self changed: #selectionIndex;
		 changed: #hasSelected.
	dialogWindow methodList changed: #list.
	dialogWindow changed: #name;
		 changed: #parameters;
		 changed: #returnDataType;
		 changed: #instance;
		 changed: #abstract! !

ClassList subclass: #ParentList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!ParentList methodsFor: 'list' stamp: 'volosmat 12/17/2013 17:52'!
selectionIndex: xIndex 
	selectedIndex := xIndex.
	
	self hasSelected
		ifTrue: [dialogWindow parentAdd: self selectedItem. ].
	self changed: #selectionIndex. 
	dialogWindow changed: #parent.
	dialogWindow parentList list: dialogWindow parent.
	dialogWindow parentList changed: #list
	
	! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 16:01'!
dialogWindow
	^ dialogWindow! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 16:01'!
dialogWindow: anObject
	dialogWindow := anObject! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 12/18/2013 00:21'!
firstItem
	^ firstItem! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 12/18/2013 00:21'!
firstItem: anObject
	firstItem := anObject! !

!GMFList methodsFor: 'list' stamp: 'volosmat 12/17/2013 17:50'!
hasSelected
	^ self selectionIndex > 1! !

!GMFList methodsFor: 'private' stamp: 'volosmat 12/17/2013 17:54'!
indexOfItem: xName in: xCollection 
	[^ (1 to: xCollection size)
		detect: [:each | (xCollection at: each)
				= xName]] 
		on: Error
		do: [^ 1]! !

!GMFList methodsFor: 'initialize-release' stamp: 'volosmat 12/18/2013 00:17'!
initialize
	firstItem := 'Select class ...'! !

!GMFList methodsFor: 'list' stamp: 'volosmat 11/27/2013 15:44'!
list
	^self subclassResponsibility.! !

!GMFList methodsFor: 'private' stamp: 'volosmat 12/17/2013 18:15'!
selectItemInList: xList item: xItem
	xList
		selectionIndex: (self indexOfItem: xItem in: xList list)! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 12/17/2013 17:50'!
selectedItem
	^ self list at: self selectionIndex! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 12/17/2013 17:50'!
selectionIndex
	^ selectedIndex ifNil: [ selectedIndex := 1 ]! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 12/19/2013 20:17'!
selectionIndex: xIndex
	^ self subclassResponsibility ! !

GMFList subclass: #MethodList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!MethodList methodsFor: 'list' stamp: 'volosmat 11/27/2013 19:15'!
list
	| methodsList |
	methodsList := OrderedCollection new.
	methodsList add: 'New method'.
	dialogWindow classList hasSelected
		ifTrue: [(Facade getClass: dialogWindow classList selectedItem) metaModelClass methods 
				do: [:each | methodsList add: each name]].
	^ methodsList! !

!MethodList methodsFor: 'list' stamp: 'volosmat 12/17/2013 17:52'!
selectionIndex: xIndex 
	| method parameters |
	selectedIndex := xIndex.
	self hasSelected
		ifTrue: [method := (Facade getClass: dialogWindow classList selectedItem) metaModelClass searchMethod: self selectedItem.
			parameters := method parameters inject: '' into: [ :str :a | str , a asString, ' '. ].
			dialogWindow name: method name.
			dialogWindow returnDataType: method returnDataType.
			dialogWindow parameters: parameters.
			dialogWindow instance: method instance.
			dialogWindow abstract: method abstract];
		
		ifFalse: [dialogWindow name: nil.
			dialogWindow returnDataType: nil.
			dialogWindow parameters: 'param1 param2 param3'.
			dialogWindow instance: true.
			dialogWindow abstract: false].
	self changed: #selectionIndex;
		 changed: #hasSelected.
	dialogWindow changed: #name; 
		 changed: #parameters;
		 changed: #returnDataType;
		 changed: #instance;
		 changed: #abstract! !

ComposableModel subclass: #GMF
	instanceVariableNames: 'viewport surface openFile saveFile generateCode association element method reset attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!GMF class methodsFor: 'dialogs' stamp: 'volosmat 11/26/2013 00:03'!
alertDialog: text 
	^ UITheme builder alert: text.! !

!GMF class methodsFor: 'specs' stamp: 'volosmat 12/11/2013 22:03'!
defaultSpec
	<spec: #default>
	^ SpecLayout composed
		newColumn: [:r | 
			r newRow: [ :col | 
				col add: #saveFileButton; 
				add: #openFileButton;
				add: #generateCodeButton;
				add: #elementButton;
				add: #attributeButton;
				add: #methodButton;
				add: #associationButton;
				add: #resetButton.
				] height: 30;
			  newRow: [ :col1 | 
			  	col1 newColumn: [:col | col add: #viewMorph ] ] ]! !

!GMF class methodsFor: 'open' stamp: 'volosmat 12/21/2013 10:01'!
open
	^ self new openWithSpec extent: 950@600! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 21:56'!
association
	AssociationWindow new 
		openModal.
		
	self viewMorph changed.! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/26/2013 17:01'!
associationButton
	^association! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 12/11/2013 22:04'!
attribute
	AttributeWindow new 
		openModal.
		
	self viewMorph changed.! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 12/11/2013 22:05'!
attributeButton
	^attribute! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 21:57'!
element
	ElementWindow new 
		openModal.
	
	self viewMorph changed.
! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/26/2013 17:01'!
elementButton
	^ element! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 12/20/2013 00:55'!
generateCode
	Facade clearPackage: 'generatedClasses'.
	(Facade getClasses
		allSatisfy: [:each | each metaModelClass validateClassName & each metaModelClass validateClass])
		ifTrue: [Facade generate];
		
		ifFalse: [GMF alertDialog: 'Error in checking OntoUML rules or elements names.']! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
generateCodeButton
	^ generateCode! !

!GMF methodsFor: 'initialization' stamp: 'volosmat 12/11/2013 22:05'!
initializePresenter

	openFile whenActionPerformedDo: [  self openFile ].
	saveFile whenActionPerformedDo: [ self saveFile ].
	element whenActionPerformedDo: [ self element ].
	attribute whenActionPerformedDo: [ self attribute ].
	method whenActionPerformedDo: [ self method ].
	association whenActionPerformedDo: [ self association ].
	generateCode whenActionPerformedDo: [ self generateCode ].
	reset whenActionPerformedDo: [ self reset ]! !

!GMF methodsFor: 'initialization' stamp: 'volosmat 12/21/2013 10:01'!
initializeWidgets 
		self instantiateModels: #(
		openFile		 	ButtonModel
		saveFile		 	ButtonModel
		#element   			ButtonModel
		#attribute   		ButtonModel
		#method   			ButtonModel
		#association  		ButtonModel
		#reset 				ButtonModel 
		generateCode   	ButtonModel
	).
		reset 
			label: 'Remove diagram';
			state: false.
		saveFile
			label: 'Save'; 
			state: false.
		openFile 
			label: 'Open'; 
			state: false.
		generateCode 
			label: 'Generate'; 
			state: false.
		element 
			label: 'Element'; 
			state: false.
		attribute 
			label: 'Attribute'; 
			state: false.
		method
			label: 'Method'; 
			state: false.
		association
			label: 'Association'; 
			state: false.! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 21:57'!
method
	MethodWindow new 
		openModal.
	
	self viewMorph changed.! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/26/2013 17:02'!
methodButton
	^method! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 12/4/2013 12:14'!
openFile
	Facade loadDiagram! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
openFileButton
	^openFile! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 12/19/2013 14:44'!
reset
	Facade clearData.
	
	self viewMorph changed.! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/28/2013 21:23'!
resetButton
	^ reset! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 12/4/2013 12:14'!
saveFile
	Facade saveDiagram! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
saveFileButton
	^ saveFile! !

!GMF methodsFor: 'text' stamp: 'volosmat 11/6/2013 22:46'!
title
	^ 'GMF in Pharo'! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/28/2013 22:07'!
viewMorph
	 ^ viewport ifNil: [  viewport := GMFViewMorph new. ].! !
